local keywordHandler = KeywordHandler:new()
local npcHandler = NpcHandler:new(keywordHandler)
NpcSystem.parseParameters(npcHandler)

-- OTServ event handling functions start
function onCreatureAppear(cid)				npcHandler:onCreatureAppear(cid) end
function onCreatureDisappear(cid) 			npcHandler:onCreatureDisappear(cid) end
function onCreatureSay(cid, type, msg) 	npcHandler:onCreatureSay(cid, type, msg) end
function onThink() 						npcHandler:onThink() end
-- OTServ event handling functions end

function returnVials(cid, message, keywords, parameters, node)
	if(npcHandler.focus ~= cid) then
		return false
	end
	
	local amount = removePlayerItemsWithCharges(cid, parameters.itemid, parameters.charges)
	if(amount <= 0) then
		npcHandler:say('Nie masz ani jednego.')
	else
		local price = amount*parameters.cost
		if(doPlayerAddMoney(cid, price) == LUA_NO_ERROR) then
			npcHandler:say('Tu masz ' .. price .. ' zlotych monet. To przyjemnosc robic z toba interesy.')
		else
			error('[Error] returnVials:', 'Could not give ' .. price .. ' gold coins to player ' .. getPlayerName(cid))
		end
	end
	npcHandler:resetNpc()
	return true
end

local shopModule = ShopModule:new()
npcHandler:addModule(shopModule)

shopModule:addBuyableItem({'light wand', 'lightwand'}, 		2163, 10, 	1,	'magic light wand')
shopModule:buyContainer({'bp uhp', 'bp ultimate healthpotion'}, 	             2000, 8473, 8000, 0,  	'backpack of ultimate healt potions')
shopModule:addBuyableItem({'ultimate health potion', 'ultimate healthpotion', 'uhp'}, 		8473, 400, 	0, 	'ultimate health potion')
shopModule:buyContainer({'bp gsp', 'bp great spiritpotion'}, 	             1988, 8472, 6000, 0,  	'backpack of great spirit potions')
shopModule:addBuyableItem({'great spirit potion', 'great spiritpotion', 'gsp'}, 		8472, 300, 	0, 	'great spirit potion')
shopModule:buyContainer({'bp gmp', 'bp great mana potion'}, 	             2001, 7590, 2700, 0,  	'backpack of great mana potions')
shopModule:addBuyableItem({'great mana potion', 'great manapotion', 'gmp'}, 		7590, 120, 	0, 	'great mana potion')
shopModule:buyContainer({'bp ghp', 'bp great health potion'}, 	             2000, 7591, 3000, 0,  	'backpack of great health potions')
shopModule:addBuyableItem({'great health potion', 'great healthpotion', 'ghp'}, 		7591, 140, 	0,	'great health potion')
shopModule:buyContainer({'bp smp', 'bp strong mana potion'}, 	             2001, 7589, 1800, 0,  	'backpack of strong mana potions')
shopModule:addBuyableItem({'strong mana potion', 'strong manapotion', 'smp'}, 		7589, 80, 	0, 	'strong mana potion')
shopModule:buyContainer({'bp shp', 'bp strong health potion'}, 	             2000, 7588, 2000, 0,  	'backpack of strong health potions')
shopModule:addBuyableItem({'strong health potion', 'strong healthpotion', 'shp'}, 		7588, 90, 	0,	'strong health potion')
shopModule:buyContainer({'bp mp', 'bp mana potion'}, 	             2001, 7620, 1000, 0,  	'backpack of mana potions')
shopModule:addBuyableItem({'mana potion', 'manapotion', 'mp'}, 		7620, 50, 	0, 	'mana potion')
shopModule:buyContainer({'bp hp', 'bp health potion'}, 	             2000, 7618, 1200, 0,  	'backpack of health potions')
shopModule:addBuyableItem({'health potion', 'healthpotion', 'hp'}, 		7618, 50, 	0,	'health potion')
shopModule:buyContainer({'bp mf', 'bp manafluid'}, 	             2004, 2006, 600, 7,  	'backpack of mana fluids')
shopModule:addBuyableItem({'mana fluid', 'manafluid', 'mf'}, 		2006, 30, 	7, 	'mana fluid')
shopModule:buyContainer({'bp lf', 'bp lifefluid'}, 	             2000, 2006, 900, 10,  	'backpack of life fluids')
shopModule:addBuyableItem({'life fluid', 'lifefluid', 'lf'}, 		2006, 45, 	10,	'life fluid')
shopModule:buyContainer({'bp blank'}, 	             2003, 2260, 200, 1,  	'backpack of blank runes')
shopModule:addBuyableItem({'blank'}, 					2260, 10, 	1,	'blank rune')
shopModule:addBuyableItem({'ring', 'time', 'timering'}, 			2206, 500, 	1,	'time ring')
shopModule:addBuyableItem({'backpack', 'plecak', 'bp'}, 			1998, 10, 		'backpack')

local node = keywordHandler:addKeyword({'flask'}, StdModule.say, {npcHandler = npcHandler, onlyFocus = true, text = 'Chcesz sprzedac wszystkie swoje puste viale po 5 zlotych monet za sztuke?'})
	node:addChildKeyword({'yes'}, returnVials, {itemid = 2006, charges = 0, cost = 5})
	node:addChildKeyword({'no'}, StdModule.say, {npcHandler = npcHandler, onlyFocus = true, reset = true, text = 'Ok.'})
	
local node = keywordHandler:addKeyword({'empty potions'}, StdModule.say, {npcHandler = npcHandler, onlyFocus = true, text = 'Chcesz sprzedac wszystkie swoje puste potiony po 7 zlotych monet za sztuke?'})
	node:addChildKeyword({'yes'}, returnVials, {itemid = 7636, charges = 0, cost = 7})
	node:addChildKeyword({'no'}, StdModule.say, {npcHandler = npcHandler, onlyFocus = true, reset = true, text = 'Ok.'})
keywordHandler:addKeyword({'potions'},        StdModule.say, {npcHandler = npcHandler, onlyFocus = true, text = 'Mam w ofercie mana potions[mp], strong mana potions[smp], great mana potions[gmp], great spiritpotion[gsp], health potions[hp], strong health potions[shp], great health potions[ghp], ultimate health potions[uhp]. Sprzedaje tez potiony w plecakach np. [bp shp] lub [bp smp].'})
npcHandler:addModule(FocusModule:new())
