local keywordHandler = KeywordHandler:new()
local npcHandler = NpcHandler:new(keywordHandler)
NpcSystem.parseParameters(npcHandler)

-- OTServ event handling functions start
function onCreatureAppear(cid)				npcHandler:onCreatureAppear(cid) end
function onCreatureDisappear(cid) 			npcHandler:onCreatureDisappear(cid) end
function onCreatureSay(cid, type, msg) 	npcHandler:onCreatureSay(cid, type, msg) end
function onThink() 						npcHandler:onThink() end
-- OTServ event handling functions end

local shopModule = ShopModule:new()
npcHandler:addModule(shopModule)

shopModule:addBuyableItem({'blood herb'}, 		2798, 1000, 	1,	'blood herb')
shopModule:addBuyableItem({'square table'}, 		3901, 50, 	1,	'square table')
shopModule:addBuyableItem({'small round table'}, 		3902, 50, 	1,	'small round table')
shopModule:addBuyableItem({'small table'}, 		3903, 50, 	1,	'small table')
shopModule:addBuyableItem({'wooden chair'}, 		3904, 50, 	1,	'wooden chair')
shopModule:addBuyableItem({'sofa chair'}, 		3905, 50, 	1,	'sofa chair')
shopModule:addBuyableItem({'red cushioned chair'}, 		3906, 50, 	1,	'red cushioned chair')
shopModule:addBuyableItem({'green cushioned chair'}, 		3907, 50, 	1,	'green cushioned chair')
shopModule:addBuyableItem({'rocking chair'}, 		3908, 50, 	1,	'rocking chair')
shopModule:addBuyableItem({'drawers'}, 		3909, 50, 	1,	'drawers')
shopModule:addBuyableItem({'bookcase'}, 		3910, 50, 	1,	'bookcase')
shopModule:addBuyableItem({'pendulum clock'}, 		3911, 50, 	1,	'pendulum clock')
shopModule:addBuyableItem({'locker'}, 		3912, 50, 	1,	'locker')
shopModule:addBuyableItem({'piano'}, 		3913, 50, 	1,	'piano')
shopModule:addBuyableItem({'harp'}, 		3914, 50, 	1,	'harp')
shopModule:addBuyableItem({'chest'}, 		3915, 50, 	1,	'chest')
shopModule:addBuyableItem({'dresser'}, 		3916, 50, 	1,	'dresser')
shopModule:addBuyableItem({'rocking horse'}, 		3917, 50, 	1,	'rocking horse')
shopModule:addBuyableItem({'telescope'}, 		3918, 50, 	1,	'telescope')
shopModule:addBuyableItem({'stone table'}, 		3919, 50, 	1,	'stone table')
shopModule:addBuyableItem({'tusk table'}, 		3920, 50, 	1,	'tusk table')
shopModule:addBuyableItem({'bamboo table'}, 		3921, 50, 	1,	'bamboo table')
shopModule:addBuyableItem({'water-pipe', 'water pipe'}, 		3922, 50, 	1,	'water-pipe')
shopModule:addBuyableItem({'bird cage'}, 		3923, 50, 	1,	'bird cage')
shopModule:addBuyableItem({'globe'}, 		3924, 50, 	1,	'globe')
shopModule:addBuyableItem({'indoor plant'}, 		3925, 50, 	1,	'indoor plant')
shopModule:addBuyableItem({'potted flower'}, 		3928, 50, 	1,	'potted flower')
shopModule:addBuyableItem({'christmas tree'}, 		3929, 50, 	1,	'christmas tree')
shopModule:addBuyableItem({'tusk chair'}, 		3930, 50, 	1,	'tusk chair')
shopModule:addBuyableItem({'bamboo drawer'}, 		3934, 50, 	1,	'bamboo drawer')
shopModule:addBuyableItem({'ivory chair'}, 		3935, 50, 	1,	'ivory chair')
shopModule:addBuyableItem({'big table'}, 		3938, 50, 	1,	'big table')
shopModule:addBuyableItem({'box'}, 		1738, 50, 	1,	'box')
shopModule:addBuyableItem({'pirate tapestry'}, 		5616, 500, 	1,	'pirate tapestry')
shopModule:addBuyableItem({'white tapestry'}, 		1880, 50, 	1,	'white tapestry')
shopModule:addBuyableItem({'blue tapestry'}, 		1872, 50, 	1,	' tapestry')
shopModule:addBuyableItem({'red tapestry'}, 		1869, 50, 	1,	'red tapestry')
shopModule:addBuyableItem({'orange tapestry'}, 		1866, 50, 	1,	'orange tapestry')
shopModule:addBuyableItem({'yellow tapestry'}, 		1863, 50, 	1,	'yellow tapestry')
shopModule:addBuyableItem({'green tapestry'}, 		1860, 50, 	1,	'green tapestry')
shopModule:addBuyableItem({'purple tapestry'}, 		1857, 50, 	1,	'purple tapestry')
shopModule:addBuyableItem({'demon trophy'}, 		7393, 30000, 	1,	'demon trophy')
shopModule:addBuyableItem({'wolf trophy'}, 		7394, 200, 	1,	'wolf trophy')
shopModule:addBuyableItem({'orc trophy'}, 		7395, 500, 	1,	'orc trophy')
shopModule:addBuyableItem({'behemoth trophy'}, 		7396, 9000, 	1,	'behemoth trophy')
shopModule:addBuyableItem({'deer trophy'}, 		7397, 100, 	1,	'deer trophy')
shopModule:addBuyableItem({'cyclops trophy'}, 		7398, 2000, 	1,	'cyclops trophy')
shopModule:addBuyableItem({'dragon lord trophy'}, 		7399, 15000, 	1,	'dragon lord trophy')
shopModule:addBuyableItem({'lion trophy'}, 		7400, 400, 	1,	'lion trophy')
shopModule:addBuyableItem({'minotaur trophy'}, 		7401, 300, 	1,	'minotaur trophy')
shopModule:addBuyableItem({'bat decoration'}, 		6492, 2500, 	1,	'bat decoration')
shopModule:addBuyableItem({'skeleton decoration'}, 		6526, 500, 	1,	'skeleton decoration')
shopModule:addBuyableItem({'green bed'}, 		7904, 1000, 	1,	'green bed modification')
shopModule:addBuyableItem({'red bed'}, 		7905, 1000, 	1,	'red bed modification')
shopModule:addBuyableItem({'yellow bed'}, 		7906, 1000, 	1,	'yellow bed modification')
shopModule:addBuyableItem({'remove bed'}, 		7907, 1000, 	1,	'remove bed midification')

npcHandler:addModule(FocusModule:new())
