local keywordHandler = KeywordHandler:new()
local npcHandler = NpcHandler:new(keywordHandler)
NpcSystem.parseParameters(npcHandler)



-- OTServ event handling functions start
function onCreatureAppear(cid)				npcHandler:onCreatureAppear(cid) end
function onCreatureDisappear(cid) 			npcHandler:onCreatureDisappear(cid) end
function onCreatureSay(cid, type, msg) 	npcHandler:onCreatureSay(cid, type, msg) end
function onThink() 						npcHandler:onThink() end
-- OTServ event handling functions end


function returnVials(cid, message, keywords, parameters, node)
	if(npcHandler.focus ~= cid) then
		return false
	end
	
	local amount = removePlayerItemsWithCharges(cid, parameters.itemid, parameters.charges)
	if(amount <= 0) then
		npcHandler:say('Nie masz ani jednego.')
	else
		local price = amount*parameters.cost
		if(doPlayerAddMoney(cid, price) == LUA_NO_ERROR) then
			npcHandler:say('Tu masz ' .. price .. ' zlotych monet. To przyjemnosc robic z toba interesy.')
		else
			error('[Error] returnVials:', 'Could not give ' .. price .. ' gold coins to player ' .. getPlayerName(cid))
		end
	end
	npcHandler:resetNpc()
	return true
end



local shopModule = ShopModule:new()
npcHandler:addModule(shopModule)

shopModule:buyContainer({'bp mega hmm'}, 	             2001, 2311, 2000, 45,  	'backpack of MEGA heavy magic missile runes')
shopModule:addBuyableItem({'mega heavy magic missile', 'mega hmm'}, 	2311, 100, 	45,	'MEGA heavy magic missile rune')
shopModule:buyContainer({'bp mega gfb'}, 	             2000, 2304, 5600, 12,  	'backpack of MEGA great fireball runes')
shopModule:addBuyableItem({'mega great fireball', 'mega gfb'}, 			2304, 280, 	12, 	'MEGA great fireball rune')
shopModule:buyContainer({'bp mega exp', 'bp explosion'}, 	             2001, 2313, 12000,18,  	'backpack of MEGA explosion runes')
shopModule:addBuyableItem({'mega explo', 'mega xpl'}, 					2313, 600, 	18, 	'explosion rune')
shopModule:buyContainer({'bp mega uh'}, 	             2002, 2273, 8000, 6,  	'backpack of MEGA ultimate healing runes')
shopModule:addBuyableItem({'mega ultimate healing', 'mega uh'}, 		2273, 200, 	6, 	'MEGA ultimate healing rune')
shopModule:buyContainer({'bp mega sd'}, 	             2003, 2268, 16000, 6,  	'backpack of MEGA sudden death runes')
shopModule:addBuyableItem({'mega sudden death', 'mega sd'}, 			2268, 800, 	6, 	'MEGA sudden death rune')

shopModule:addBuyableItem({'light wand', 'lightwand'}, 		2163, 10, 	1,	'magic light wand')
shopModule:buyContainer({'bp uhp', 'bp ultimate healthpotion'}, 	             2000, 8473, 8000, 0,  	'backpack of ultimate healt potions')
shopModule:addBuyableItem({'ultimate health potion', 'ultimate healthpotion', 'uhp'}, 		8473, 400, 	0, 	'ultimate health potion')
shopModule:buyContainer({'bp gsp', 'bp great spiritpotion'}, 	             1988, 8472, 6000, 0,  	'backpack of great spirit potions')
shopModule:addBuyableItem({'great spirit potion', 'great spiritpotion', 'gsp'}, 		8472, 300, 	0, 	'great spirit potion')
shopModule:buyContainer({'bp gmp', 'bp great mana potion'}, 	             2001, 7590, 2700, 0,  	'backpack of great mana potions')
shopModule:addBuyableItem({'great mana potion', 'great manapotion', 'gmp'}, 		7590, 120, 	0, 	'great mana potion')
shopModule:buyContainer({'bp ghp', 'bp great health potion'}, 	             2000, 7591, 3000, 0,  	'backpack of great health potions')
shopModule:addBuyableItem({'great health potion', 'great healthpotion', 'ghp'}, 		7591, 140, 	0,	'great health potion')
shopModule:buyContainer({'bp smp', 'bp strong mana potion'}, 	             2001, 7589, 1800, 0,  	'backpack of strong mana potions')
shopModule:addBuyableItem({'strong mana potion', 'strong manapotion', 'smp'}, 		7589, 80, 	0, 	'strong mana potion')
shopModule:buyContainer({'bp shp', 'bp strong health potion'}, 	             2000, 7588, 2000, 0,  	'backpack of strong health potions')
shopModule:addBuyableItem({'strong health potion', 'strong healthpotion', 'shp'}, 		7588, 90, 	0,	'strong health potion')
shopModule:buyContainer({'bp mp', 'bp mana potion'}, 	             2001, 7620, 1000, 0,  	'backpack of mana potions')
shopModule:addBuyableItem({'mana potion', 'manapotion', 'mp'}, 		7620, 50, 	0, 	'mana potion')
shopModule:buyContainer({'bp hp', 'bp health potion'}, 	             2000, 7618, 1200, 0,  	'backpack of health potions')
shopModule:addBuyableItem({'health potion', 'healthpotion', 'hp'}, 		7618, 50, 	0,	'health potion')
shopModule:buyContainer({'bp mf', 'bp manafluid'}, 	             2004, 2006, 600, 7,  	'backpack of mana fluids')
shopModule:addBuyableItem({'mana fluid', 'manafluid', 'mf'}, 		2006, 30, 	7, 	'mana fluid')
shopModule:buyContainer({'bp lf', 'bp lifefluid'}, 	             2000, 2006, 900, 10,  	'backpack of life fluids')
shopModule:addBuyableItem({'life fluid', 'lifefluid', 'lf'}, 		2006, 45, 	10,	'life fluid')
shopModule:buyContainer({'bp hmm'}, 	             2001, 2311, 500, 2,  	'backpack of heavy magic missile runes')
shopModule:addBuyableItem({'heavy magic missile', 'hmm'}, 	2311, 25, 	2,	'heavy magic missile rune')
shopModule:buyContainer({'bp gfb'}, 	             2000, 2304, 1400, 4,  	'backpack of great fireball runes')
shopModule:addBuyableItem({'great fireball', 'gfb'}, 			2304, 70, 	4, 	'great fireball rune')
shopModule:buyContainer({'bp exp', 'bp explosion'}, 	             2001, 2313, 3000, 6,  	'backpack of explosion runes')
shopModule:addBuyableItem({'explo', 'xpl'}, 					2313, 150, 	6, 	'explosion rune')
shopModule:buyContainer({'bp uh'}, 	             2002, 2273, 2000, 2,  	'backpack of ultimate healing runes')
shopModule:addBuyableItem({'ultimate healing', 'uh'}, 		2273, 50, 	2, 	'ultimate healing rune')
shopModule:buyContainer({'bp sd'}, 	             2003, 2268, 4000, 2,  	'backpack of sudden death runes')
shopModule:addBuyableItem({'sudden death', 'sd'}, 			2268, 200, 	2, 	'sudden death rune')
shopModule:buyContainer({'bp ih'}, 	             2003, 2265, 1000, 4,  	'backpack of intense healing runes')
shopModule:addBuyableItem({'intense healing', 'ih'}, 			2265, 50, 	4, 	'intense healing rune')
shopModule:buyContainer({'bp mw'}, 	             2004, 2293, 2000, 3,  	'backpack of magic wall runes')
shopModule:addBuyableItem({'magic wall', 'mw'}, 			2293, 50, 	3, 	'magic wall rune')
shopModule:buyContainer({'bp ds'}, 	             2003, 2261, 300, 3,  	'backpack of destroy field runes')
shopModule:addBuyableItem({'destroy field', 'ds'}, 			2261, 10, 	3, 	'destroy field rune')
shopModule:buyContainer({'bp blank'}, 	             2003, 2260, 200, 1,  	'backpack of blank runes')
shopModule:addBuyableItem({'blank'}, 					2260, 10, 	1,	'blank rune')

shopModule:addBuyableItem({'wand of inferno', 'inferno'}, 				2187, 15000, 	'wand of inferno')
shopModule:addBuyableItem({'wand of decay', 'decay'}, 				2188, 5000, 	'wand of decay')
shopModule:addBuyableItem({'wand of cosmic energy', 'cosmic energy'}, 	2189, 10000, 	'wand of cosmic energy')
shopModule:addBuyableItem({'wand of vortex', 'vortex'}, 				2190, 500, 	 	'wand of vortex')
shopModule:addBuyableItem({'wand of dragonbreath', 'dragonbreath'}, 	2191, 1000, 	'wand of dragonbreath')

shopModule:addBuyableItem({'terra rod', 'terra'}, 				2181, 10000, 	'terra rod')
shopModule:addBuyableItem({'snakebite rod', 'snakebite'}, 				2182, 500, 	 	'snakebite rod')
shopModule:addBuyableItem({'hailstorm rod', 'hailstorm'}, 					2183, 15000, 	'hailstorm rod')
shopModule:addBuyableItem({'necrotic rod', 'necrotic'}, 				2185, 5000, 	'necrotic rod')
shopModule:addBuyableItem({'moonlight rod', 'moonlight'}, 				2186, 1000,   	'moonlight rod')



local node = keywordHandler:addKeyword({'flask'}, StdModule.say, {npcHandler = npcHandler, onlyFocus = true, text = 'Chcesz sprzedac wszystkie swoje puste viale po 5 zlotych monet za sztuke?'})
	node:addChildKeyword({'yes'}, returnVials, {itemid = 2006, charges = 0, cost = 5})
	node:addChildKeyword({'no'}, StdModule.say, {npcHandler = npcHandler, onlyFocus = true, reset = true, text = 'Ok.'})
	
local node = keywordHandler:addKeyword({'empty potions'}, StdModule.say, {npcHandler = npcHandler, onlyFocus = true, text = 'Chcesz sprzedac wszystkie swoje puste potiony po 7 zlotych monet za sztuke?'})
	node:addChildKeyword({'yes'}, returnVials, {itemid = 7636, charges = 0, cost = 7})
	node:addChildKeyword({'no'}, StdModule.say, {npcHandler = npcHandler, onlyFocus = true, reset = true, text = 'Ok.'})
keywordHandler:addKeyword({'potions'},        StdModule.say, {npcHandler = npcHandler, onlyFocus = true, text = 'Mam w ofercie mana potions[mp], strong mana potions[smp], great mana potions[gmp], great spiritpotion[gsp], health potions[hp], strong health potions[shp], great health potions[ghp], ultimate health potions[uhp]. Sprzedaje tez potiony w plecakach np. [bp shp] lub [bp smp].'})

npcHandler:addModule(FocusModule:new())