local keywordHandler = KeywordHandler:new()
local npcHandler = NpcHandler:new(keywordHandler)
NpcSystem.parseParameters(npcHandler)

function onCreatureAppear(cid)		npcHandler:onCreatureAppear(cid)		end
function onCreatureDisappear(cid)	npcHandler:onCreatureDisappear(cid)		end
function onCreatureSay(cid, type, msg)	npcHandler:onCreatureSay(cid, type, msg)	end
function onThink()			npcHandler:onThink()				end

function creatureSayCallback(cid, type, msg)
	if(npcHandler.focus ~= cid) then
		return false
	end
	msg = string.lower(msg)
	if msgcontains(msg, 'cwicz') or msgcontains(msg, 'mroczn') then
		if getPlayerVocation(cid) == 5 then
			selfSay('Chcialbys zostac mrocznym magiem? Tak?')
			talk_state = 1
		elseif getPlayerVocation(cid) == 9 then
			selfSay('Juz jestes Mrocznym Magiem. Nie bede Ciebie uczyl w kolko tego samego.')
			talk_state = 0
		else
			selfSay('Cwicze tylko z poteznymi magami. Inne osoby moga co najwyzej dostac stroj maga za odpowiednia oplata.')
			talk_state = 0
		end
	elseif talk_state == 1 then
		if msgcontains(msg, 'tak') or msgcontains(msg, 'yes') then
			selfSay('Mroczny Mag musi potrafic pokonac roznych przeciwnikow. Jesli chcesz awansowac musisz mi przyniesc 15 assassin star, 5 mind stone, war hammer, wand of inferno i crown legs. Masz te przedmioty przy sobie?')
			talk_state = 2
		elseif msgcontains(msg, 'nie') or msgcontains(msg, 'no') then
			selfSay('Wroc kiedy zdecydujesz sie na cwiczenia.')
			talk_state = 0
		end
	elseif talk_state == 2 then
		if (msgcontains(msg, 'tak') or msgcontains(msg, 'yes')) and getPlayerItemCount(cid,7368) >= 15 and getPlayerItemCount(cid,2178) >= 5 and getPlayerItemCount(cid,2391) >= 1 and getPlayerItemCount(cid,2187) >= 1 and getPlayerItemCount(cid,2488) >= 1 then
			doPlayerTakeItem(cid,7368,15)
			doPlayerTakeItem(cid,2178,5)
			doPlayerTakeItem(cid,2391,1)
			doPlayerTakeItem(cid,2187,1)
			doPlayerTakeItem(cid,2488,1)
			doPlayerAddOutfit(cid, 145, 2) --wizard add 2
			doPlayerAddOutfit(cid, 149, 2) --wizard add 2
			setPlayerStorageValue(cid,110001,1) --potwierdzenie wizard add 2 
			doPlayerAddOutfit(cid, 145, 1) --wizard add 1
			doPlayerAddOutfit(cid, 149, 1) --wizard add 1
			setPlayerStorageValue(cid,110002,1) --potwierdzenie wizard add 1
			doPlayerAddOutfit(cid, 130, 2) --mage add 2
			doPlayerAddOutfit(cid, 138, 2) --mage add 2
			doPlayerAddOutfit(cid, 130, 1) --mage add 1
			doPlayerAddOutfit(cid, 138, 1) --mage add 1
			setPlayerStorageValue(cid,50001,1) -- potwierdzenie mage add 1
			setPlayerStorageValue(cid,50002,1) -- potwierdzenie mage add 2
			doPlayerSetVocation(cid, 9)
			setPlayerStorageValue(cid, 42321, 1)
			selfSay('Gratulacje! Zostales Mrocznym Magiem. Otrzymales tez stroje odpowiednie dla magow wraz z dodatkami.')
		else
			selfSay('Wroc kiedy bedziesz mial 15 assassin star, 5 mind stone, war hammer, wand of inferno i crown legs dla mnie, i powiedz, ze chcesz pocwiczyc.')
		end
		talk_state = 0
	elseif msgcontains(msg, 'addon') or msgcontains(msg, 'stroj') or msgcontains(msg, 'maga') then
		if getPlayerVocation(cid) ~= 5 then
			selfSay('Jesli chcesz otrzymac dodatki do stroju maga musisz mi przyniesc 30.000 zlotych monet, dragon scale mail, golden legs i hailstorm rod. Masz te przedmioty przy sobie? Tak?')
			talk_state = 13
		else
			selfSay('Kazdy kto awansuje na mrocznego maga otrzymuje stroj za darmo. Lepiej zajmij sie cwiczeniami, a nie ')
		end
	elseif talk_state == 13 then
		talk_state = 0
		if msgcontains(msg, 'tak') or msgcontains(msg, 'yes') then
			if getPlayerStorageValue(cid,50002) ~= 1 and getPlayerStorageValue(cid,50001) ~= 1 then
				if getPlayerMoney(cid) >= 30000 and getPlayerItemCount(cid,2492) >= 1 and getPlayerItemCount(cid,2470) >= 1 and getPlayerItemCount(cid,2183) >= 1 then
					doPlayerRemoveMoney(cid, 30000)
					doPlayerTakeItem(cid,2492,1)
					doPlayerTakeItem(cid,2470,1)
					doPlayerTakeItem(cid,2183,1)
					doPlayerAddOutfit(cid, 130, 2) --mage add 2
					doPlayerAddOutfit(cid, 138, 2) --mage add 2
					doPlayerAddOutfit(cid, 130, 1) --mage add 1
					doPlayerAddOutfit(cid, 138, 1) --mage add 1
					setPlayerStorageValue(cid,50001,1) -- potwierdzenie mage add 1
					setPlayerStorageValue(cid,50002,1) -- potwierdzenie mage add 2
					selfSay('Dzieki za te przedmioty. Masz tu swoje dodatki do stroju maga.')
				else
					selfSay('Nie dam Ci dodatkow do stroju maga za darmo. Przyjdz kiedy bedziesz mial wymagane przedmioty.')
				end
			else
				selfSay('Masz juz stroj maga i wszystkie dodatki do niego.')
			end
		else
			selfSay('Przyjdz kiedy sie zdecydujesz i bedziesz mial wymagane przedmioty.')
		end
	end
end
--tu sie koncze skrypt NPCa
npcHandler:setCallback(CALLBACK_MESSAGE_DEFAULT, creatureSayCallback)
npcHandler:addModule(FocusModule:new())